//---------------------------------------------------------------------------
//
// Name:        wxRobotmanDlg.cpp
// Author:      daqq
// Created:     17/05/2008 12:29:17
// Description: wxRobotmanDlg class implementation
//
//---------------------------------------------------------------------------

#include "wxRobotmanApp.h"
#include "wxRobotmanDlg.h"

#include <string>
#include <wx/utils.h> 

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
#include "Images/Self_wxRobotmanDlg_XPM.xpm"
////Header Include End





//----------------------------------------------------------------------------
// wxRobotmanDlg
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(wxRobotmanDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(wxRobotmanDlg::OnClose)
	EVT_ACTIVATE(wxRobotmanDlg::wxRobotmanDlgActivate)
	EVT_TIMER(ID_UPDATE_TIMER,wxRobotmanDlg::update_timerTimer)
	EVT_CHECKBOX(ID_CHECK_L3,wxRobotmanDlg::check_l0Click)
	EVT_CHECKBOX(ID_CHECK_L2,wxRobotmanDlg::check_l0Click)
	EVT_CHECKBOX(ID_CHECK_L1,wxRobotmanDlg::check_l0Click)
	EVT_CHECKBOX(ID_CHECK_L0,wxRobotmanDlg::check_l0Click)
	EVT_BUTTON(ID_TESTIE,wxRobotmanDlg::testieClick)
	EVT_BUTTON(ID_B_EXIT,wxRobotmanDlg::b_exitClick)
	EVT_BUTTON(ID_B_CONNECT,wxRobotmanDlg::b_connectClick)
	EVT_BUTTON(ID_B_STOP,wxRobotmanDlg::b_stopClick)
	EVT_BUTTON(ID_B_BACKWARD,wxRobotmanDlg::b_backwardClick)
	EVT_BUTTON(ID_B_LEFT,wxRobotmanDlg::b_leftClick)
	EVT_BUTTON(ID_B_RIGHT,wxRobotmanDlg::b_rightClick)
	EVT_BUTTON(ID_B_FORWARD,wxRobotmanDlg::b_forwardClick)
END_EVENT_TABLE()
////Event Table End

wxRobotmanDlg::wxRobotmanDlg(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
    connected = false;
	CreateGUIControls();
    WxHyperLinkCtrl1->SetURL("http://www.robotika.sk");
    text_battery_stat->SetEditable(false);
}

wxRobotmanDlg::~wxRobotmanDlg()
{
} 

void wxRobotmanDlg::CreateGUIControls()
{

	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End.
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	SetTitle(wxT("Sbot2.0 : RobotManager"));
	SetIcon(Self_wxRobotmanDlg_XPM);
	SetSize(8,8,342,560);
	Center();
	

	update_timer = new wxTimer();
	update_timer->SetOwner(this, ID_UPDATE_TIMER);

	WxStaticText4 = new wxStaticText(this, ID_WXSTATICTEXT4, wxT("by David Gustafik"), wxPoint(16,496), wxDefaultSize, 0, wxT("WxStaticText4"));
	WxStaticText4->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxHyperLinkCtrl1 = new wxHyperlinkCtrl(this, ID_WXHYPERLINKCTRL1, wxT("www.robotika.sk"), wxT("http://wxdsgn.sf.net"), wxPoint(224,496), wxSize(89, 17), wxNO_BORDER | wxHL_CONTEXTMENU, wxT("WxHyperLinkCtrl1"));
	WxHyperLinkCtrl1->SetNormalColour(*wxBLUE);
	WxHyperLinkCtrl1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, true));

	WxStaticLine1 = new wxStaticLine(this, ID_WXSTATICLINE1, wxPoint(195,16), wxSize(-1,318), wxLI_VERTICAL);
	WxStaticLine1->SetForegroundColour(*wxBLUE);
	WxStaticLine1->SetBackgroundColour(wxColour(*wxWHITE));
	WxStaticLine1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	check_l3 = new wxCheckBox(this, ID_CHECK_L3, wxT("3"), wxPoint(216,216), wxSize(25,17), 0, wxDefaultValidator, wxT("check_l3"));
	check_l3->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	check_l2 = new wxCheckBox(this, ID_CHECK_L2, wxT("2"), wxPoint(216,200), wxSize(25,17), 0, wxDefaultValidator, wxT("check_l2"));
	check_l2->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	check_l1 = new wxCheckBox(this, ID_CHECK_L1, wxT("1"), wxPoint(216,184), wxSize(25,17), 0, wxDefaultValidator, wxT("check_l1"));
	check_l1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	check_l0 = new wxCheckBox(this, ID_CHECK_L0, wxT("0"), wxPoint(216,168), wxSize(25,17), 0, wxDefaultValidator, wxT("check_l0"));
	check_l0->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticBox1 = new wxStaticBox(this, ID_WXSTATICBOX1, wxT("LEDs:"), wxPoint(208,152), wxSize(41,89));
	WxStaticBox1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	check_log_out_packets = new wxCheckBox(this, ID_CHECK_LOG_OUT_PACKETS, wxT("Log outgoing packets"), wxPoint(16,312), wxSize(129,17), 0, wxDefaultValidator, wxT("check_log_out_packets"));
	check_log_out_packets->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText3 = new wxStaticText(this, ID_WXSTATICTEXT3, wxT("Robot name:"), wxPoint(208,104), wxDefaultSize, 0, wxT("WxStaticText3"));
	WxStaticText3->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	text_robot_name = new wxTextCtrl(this, ID_TEXT_ROBOT_NAME, wxT("0"), wxPoint(208,128), wxSize(105,17), 0, wxDefaultValidator, wxT("text_robot_name"));
	text_robot_name->SetMaxLength(1);
	text_robot_name->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	testie = new wxButton(this, ID_TESTIE, wxT("testie"), wxPoint(40,280), wxSize(81,25), 0, wxDefaultValidator, wxT("testie"));
	testie->Show(false);
	testie->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	text_battery_stat = new wxTextCtrl(this, ID_TEXT_BATTERY_STAT, wxT("---"), wxPoint(208,272), wxSize(105,17), 0, wxDefaultValidator, wxT("text_battery_stat"));
	text_battery_stat->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, wxT("Battery status:"), wxPoint(208,248), wxDefaultSize, 0, wxT("WxStaticText2"));
	WxStaticText2->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	wxArrayString arrayStringFor_l_log;
	l_log = new wxListBox(this, ID_L_LOG, wxPoint(16,344), wxSize(297,145), arrayStringFor_l_log, wxLB_SINGLE | wxLB_HSCROLL);
	l_log->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("COM port name:"), wxPoint(208,56), wxDefaultSize, 0, wxT("WxStaticText1"));
	WxStaticText1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	text_comport = new wxTextCtrl(this, ID_TEXT_COMPORT, wxT("COM1"), wxPoint(208,80), wxSize(105,17), 0, wxDefaultValidator, wxT("text_comport"));
	text_comport->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	b_exit = new wxButton(this, ID_B_EXIT, wxT("Exit"), wxPoint(208,296), wxSize(105,33), 0, wxDefaultValidator, wxT("b_exit"));
	b_exit->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	b_connect = new wxButton(this, ID_B_CONNECT, wxT("Connect"), wxPoint(208,16), wxSize(105,33), 0, wxDefaultValidator, wxT("b_connect"));
	b_connect->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	wxArrayString arrayStringFor_list_sens_stat;
	list_sens_stat = new wxListBox(this, ID_LIST_SENS_STAT, wxPoint(16,16), wxSize(169,161), arrayStringFor_list_sens_stat, wxLB_SINGLE);
	list_sens_stat->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	b_stop = new wxButton(this, ID_B_STOP, wxT("STOP"), wxPoint(80,216), wxSize(49,25), 0, wxDefaultValidator, wxT("b_stop"));
	b_stop->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	b_backward = new wxButton(this, ID_B_BACKWARD, wxT("BW"), wxPoint(80,248), wxSize(49,25), 0, wxDefaultValidator, wxT("b_backward"));
	b_backward->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	b_left = new wxButton(this, ID_B_LEFT, wxT("L"), wxPoint(40,216), wxSize(33,25), 0, wxDefaultValidator, wxT("b_left"));
	b_left->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	b_right = new wxButton(this, ID_B_RIGHT, wxT("R"), wxPoint(136,216), wxSize(33,25), 0, wxDefaultValidator, wxT("b_right"));
	b_right->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	b_forward = new wxButton(this, ID_B_FORWARD, wxT("FW"), wxPoint(80,184), wxSize(49,25), 0, wxDefaultValidator, wxT("b_forward"));
	b_forward->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	////GUI Items Creation End
}



void wxRobotmanDlg::OnClose(wxCloseEvent& /*event*/)
{
	Destroy();
}




int wxRobotmanDlg::COMgetch(void)
{
    DWORD count=0;
    unsigned char Data = 0;

    ReadFile(this->hCom,&Data,1,&count,NULL);
        
    if( count != 1 ) return EMPTY_SERIAL_BUFFER;    //if the buffer is empty
    else return Data;   //or return the data we received
}




void wxRobotmanDlg::b_connectClick(wxCommandEvent& event)
{
    char buffer;
    char buf[100];
    strcpy( buf, (const char*)text_robot_name->GetValue().mb_str(wxConvUTF8) );
    buffer = buf[0];
    wxString s; //extracts the first char of the text
    
    if(connected == false)  //this means we aren't connected. therefore we act as the connect button....
    {
        if(!this->COMConnect(text_comport->GetValue()+":"))  //error checking : if we aren't able toh_nect we get a true 
        {
            text_comport->SetEditable(false);
            text_robot_name->SetEditable(false);
            robot_name = buffer;
            b_connect->SetLabel("Disconnect");
            connected = true;
            s.Printf(_T("%c"), robot_name);
            PurgeComm(this->hCom,PURGE_TXCLEAR | PURGE_RXCLEAR);

            l_log->Insert( wxNow() + " : " + text_comport->GetValue() + " opened succesfully! Robot name: " + "SBOT" + s,0);
        }
        else    //error status
        {
            wxMessageBox("Could not open COM port " + text_comport->GetValue(),"Error:", wxOK, this);
        };
        update_timer->Start(1000,false);
        
    }
    else    //if we are already connected than we act as the disconnect button
    {
        connected = false; 
        text_comport->SetEditable(true);
        b_connect->SetLabel("Connect");
        text_robot_name->SetEditable(true);
        l_log->Insert( wxNow() + " : " + text_comport->GetValue() + " closed succesfully!",0);
        CloseHandle(this->hCom);
        update_timer->Stop();
    }
    
    return;
} 



bool wxRobotmanDlg::SendPacket(char input[PACKET_LENGTH])   //sends out a packet, adds the info for the checksum
{

    int temp;
    int checksum = 0;
    
    if(!connected)return false;
        
    checksum ^= input[0];
    checksum ^= input[1];
    checksum ^= input[2];
    checksum ^= input[3];
    checksum ^= input[4];
    checksum ^= input[5];
    checksum ^= input[6];
    
    bool error=false;
    
    
        
    wxString s; 
    s.Printf(_T("%c%c%c%c%c%c%c%02X\n"),input[0],input[1],input[2],input[3],input[4],input[5],input[6], checksum);
    
    for(temp = 0; temp!= PACKET_LENGTH+1; temp++) error |= this->COMputch(s.GetChar(temp));
    
    if(check_log_out_packets->GetValue()) l_log->Insert(wxNow() + ": Packet: "+ s + "  sent.",0);
    return error;
}


bool wxRobotmanDlg::COMputch(char input)   //a function to send out a 
{
    DWORD count = 0;
    if(connected == false) return true; //return an error if the comp port is not open
    WriteFile(this->hCom, &input, 1, &count, NULL); 
    
    if(count != 1) return true;  //return an error if the sending of the packet was unssuccseful
    return false;
}



bool wxRobotmanDlg::COMConnect(wxString com_name)
{
    char buf[500];
    strcpy(buf, (const char*)com_name.mb_str(wxConvUTF8) ); //convert the input string (like COM1:) to chars
    this->hCom = CreateFile( com_name, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
    
        
    if ( this->hCom == INVALID_HANDLE_VALUE )
    {
        CloseHandle(this->hCom);
        wxMessageBox("Could not open COM port, reason: INVALID HANDLE VALUE","Error:", wxOK, this);
        return true;    //error
    };

    DCB PortDCB;
    
    PortDCB.DCBlength = sizeof(DCB);
    GetCommState(this->hCom,&PortDCB);
    
    PortDCB.BaudRate = 9600;           // BAUD 9600
    PortDCB.ByteSize = 8;
    PortDCB.Parity = NOPARITY;
    PortDCB.StopBits = ONESTOPBIT;
    
    if(!SetCommState(this->hCom,&PortDCB)) //write in the configuration for the port we need... and check for an error
    {
        CloseHandle(this->hCom);
        wxMessageBox("Could not open COM port, reason: DCB STATE ","Error:", wxOK, this);
        return true;    //if an error has occured, we inform the upper system. 
    }
    
    COMMTIMEOUTS timeouts;
    
    timeouts.ReadIntervalTimeout         =  2;
    timeouts.ReadTotalTimeoutMultiplier  =  2;
    timeouts.ReadTotalTimeoutConstant    = 2;
    timeouts.WriteTotalTimeoutMultiplier =  2;
    timeouts.ReadTotalTimeoutConstant    = 2;
    
    if (!SetCommTimeouts(hCom,&timeouts))
    {
        CloseHandle(this->hCom);
        wxMessageBox("Could not open COM port, reason: BAD TIMEOUT SETTINGS","Error:", wxOK, this);
        return true;
    };
    return false; 
}




/*
 * b_exitClick
 */
void wxRobotmanDlg::b_exitClick(wxCommandEvent& event)
{
    //the exiting procedure for the form. closes the com port and ends. 
    CloseHandle(this->hCom);
    Destroy();
}



int wxRobotmanDlg::hex_to_dec(char in) 
{ 
   if(((in >= '0') && (in <= '9'))) return in-'0'; 
   in |= 0x20; 
   if(((in >= 'a') && (in <= 'f'))) return in-'a' + 10; 
   return HEX_DEC_ERROR; 
}




/*
 * update_timerTimer
 */
void wxRobotmanDlg::update_timerTimer(wxTimerEvent& event)
{
    static int sensor_states_bumper[] = {0,0,0,0};
    static int sensor_states_analog[] = {0,0,0,0,0,0,0,0};
    int input, tries = 0,temp;
    bool end = false;
    char buffer[500];
    bool com_inited = false;
    int com_state = 0;
    float battery_status = 0.0;
    wxString s;

    char packet_out[PACKET_LENGTH];
    
    //ask the robot on the state of the analog sensors
    packet_out[0] = '!';  //start of packet, can be either ? or !   
    packet_out[1] = robot_name;  //name of robot
    packet_out[2] = 'a';  //command name
    packet_out[3] = '0';  //parameter 1
    packet_out[4] = '0';  //parameter 2
    packet_out[5] = '0';  //parameter 3
    packet_out[6] = '0';  //parameter 4
    for(temp = 0; temp<8; temp++)
    {
        packet_out[6] = '0' + temp;
        SendPacket(packet_out);
        wxMilliSleep(3);
    }

    //ask the robot on the status of the bumper sensors
    packet_out[0] = '!';  //start of packet, can be either ? or !
    packet_out[1] = robot_name;  //name of robot
    packet_out[2] = 'j';  //command name
    packet_out[3] = '0';  //parameter 1
    packet_out[4] = '0';  //parameter 2
    packet_out[5] = '0';  //parameter 3
    packet_out[6] = '0';  //parameter 4
    SendPacket(packet_out);
    wxMilliSleep(10);
    
    while(end != true)
    {
        input = COMgetch();
        if(++tries == 50)
        {
            end = true;  //combined with the com_timeout we get a 50ms waiting time for the packet
            continue;
        };
        if(input == EMPTY_SERIAL_BUFFER) continue;; //if the data buffer is empty we simply continue
        if(com_inited == false && input != '!') continue;;   //we ignore any data that has not been preceded by a '!' character
        
        if(input == '!')    //the star of a new incoming packet
        {
            com_inited = true;
            tries = 0;
            buffer[0] = '!';
            com_state = 1;
            continue;
        };
        
        buffer[com_state++] = input;
        tries = 0;        
        
        if(com_state == PACKET_LENGTH)   //we check out how much we got, and execute the following, if the packet is complete
        {
            buffer[com_state] = 0;
            com_inited = false; //we reset the communication stuff, so we can analyze another packet
            com_state = 0;
            
            if(buffer[1] != robot_name)     //the packet was not from our robot, but from some other one
            {
                s.Printf(_T("%s"),buffer);
                l_log->Insert(wxNow() + ": Packet: "+ s + "  received, but not from a different robot.",0);
                continue;
            };
            
            switch(buffer[2])   //what type of information did we get?
            {
                case REP_SENSOR_STAT_BUMPER:    //here we only store all of the stuff from the bumpers
                    sensor_states_bumper[0] = hex_to_dec(buffer[6]) & 0x01;
                    sensor_states_bumper[1] = hex_to_dec(buffer[6]) & 0x02;
                    sensor_states_bumper[2] = hex_to_dec(buffer[6]) & 0x04;
                    sensor_states_bumper[3] = hex_to_dec(buffer[6]) & 0x08;
                    break;
                    
                case REP_SENSOR_STAT_ANALOG:
                    temp = (hex_to_dec(buffer[4])*256)+(hex_to_dec(buffer[5])*16)+(hex_to_dec(buffer[6])*1);    //we extract the data from the packet, abotu the state of the analog sensor
                    sensor_states_analog[buffer[3]-'0'] = temp;
                    break;
                
                case REP_OK:
                    break;
                    
                default: 
                    s.Printf(_T("%s"),buffer);
                    l_log->Insert(wxNow() + ": Unknown packet type received: "+ s,0);
                    break;                    
            }   //end of case
        }   //end of if(packet_length);
        

    }   //end of main while

    list_sens_stat->Clear();
    for(temp= 0; temp < 8; temp++)  //update the analog values
    {
        s = "";
        s.Printf(_T("Analog %i value: %i"),temp, sensor_states_analog[temp]);
        list_sens_stat->Insert(_T(s),0);
    };
    for(temp= 0; temp < 4; temp++)  //update the analog values
    {
        s = "";
        if(sensor_states_bumper[temp] == 0)s.Printf(_T("Bumper %i value: No collision"),temp);
        else s.Printf(_T("Bumper %i value: Collision!"),temp);
        list_sens_stat->Insert(_T(s),0);
    };
    
    battery_status = (((float)sensor_states_analog[7]*2.56)/1023.0)/0.319;    //determine the battery voltage
    if(battery_status < 4.5) text_battery_stat->SetBackgroundColour(wxColour(255,0,0)); //decorational function - determines wheter the battety is OK
    else  text_battery_stat->SetBackgroundColour(wxColour(0,255,0));
    s.Printf(_T("%.03f"),battery_status);
    text_battery_stat->SetValue(s);
    
    return; 
}





void wxRobotmanDlg::testieClick(wxCommandEvent& event)
{
    char temp[PACKET_LENGTH];
    temp[0] = '!';  //start of packet, can be either ? or !
    temp[1] = robot_name;  //name of robot
    temp[2] = 'b';  //command name
    temp[3] = '1';  //parameter 1
    temp[4] = '0';  //parameter 2
    temp[5] = '1';  //parameter 3
    temp[6] = '1';  //parameter 4
    if(SendPacket(temp))wxMessageBox("BIG ERROR!!!!","Error:", wxOK, this);;
	// insert your code here
}




void wxRobotmanDlg::wxRobotmanDlgActivate(wxActivateEvent& event)
{
    
	// insert your code here
}

/*
 * b_forwardClick
 */
void wxRobotmanDlg::b_forwardClick(wxCommandEvent& event)
{
    char temp[PACKET_LENGTH];
    temp[0] = '!';  //start of packet, can be either ? or !
    temp[1] = robot_name;  //name of robot
    temp[2] = 'F';  //command name
    temp[3] = '0';  //parameter 1
    temp[4] = '0';  //parameter 2
    temp[5] = '0';  //parameter 3
    temp[6] = '0';  //parameter 4
    SendPacket(temp);
	// insert your code here
}


/*
 * b_backwardClick
 */
void wxRobotmanDlg::b_backwardClick(wxCommandEvent& event)
{
    char temp[PACKET_LENGTH];
    temp[0] = '!';  //start of packet, can be either ? or !
    temp[1] = robot_name;  //name of robot
    temp[2] = 'B';  //command name
    temp[3] = '0';  //parameter 1
    temp[4] = '0';  //parameter 2
    temp[5] = '0';  //parameter 3
    temp[6] = '0';  //parameter 4
    SendPacket(temp);
}

/*
 * b_leftClick
 */
void wxRobotmanDlg::b_leftClick(wxCommandEvent& event)
{
    char temp[PACKET_LENGTH];
    temp[0] = '!';  //start of packet, can be either ? or !
    temp[1] = robot_name;  //name of robot
    temp[2] = 'L';  //command name
    temp[3] = '0';  //parameter 1
    temp[4] = '0';  //parameter 2
    temp[5] = '0';  //parameter 3
    temp[6] = '0';  //parameter 4
    SendPacket(temp);
}


/*
 * b_rightClick
 */
void wxRobotmanDlg::b_rightClick(wxCommandEvent& event)
{
    char temp[PACKET_LENGTH];
    temp[0] = '!';  //start of packet, can be either ? or !
    temp[1] = robot_name;  //name of robot
    temp[2] = 'F';  //command name
    temp[3] = '0';  //parameter 1
    temp[4] = '0';  //parameter 2
    temp[5] = '0';  //parameter 3
    temp[6] = '0';  //parameter 4
    SendPacket(temp);
}

/*
 * b_stopClick
 */
void wxRobotmanDlg::b_stopClick(wxCommandEvent& event)
{
    char temp[PACKET_LENGTH];
    temp[0] = '!';  //start of packet, can be either ? or !
    temp[1] = robot_name;  //name of robot
    temp[2] = 'S';  //command name
    temp[3] = '0';  //parameter 1
    temp[4] = '0';  //parameter 2
    temp[5] = '0';  //parameter 3
    temp[6] = '0';  //parameter 4
    SendPacket(temp);
}

/*
 * check_l0Click
 */
void wxRobotmanDlg::check_l0Click(wxCommandEvent& event)
{
    char tab[] =  {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
    char temp[PACKET_LENGTH];
    int out_val = 0x00;
    temp[0] = '!';  //start of packet, can be either ? or !
    temp[1] = robot_name;  //name of robot
    temp[2] = 'D';  //command name
    

    if(check_l0->GetValue())out_val += 0x01;
    if(check_l1->GetValue())out_val += 0x02;
    if(check_l2->GetValue())out_val += 0x04;
    if(check_l3->GetValue())out_val += 0x08;

    temp[3] = '0';
    temp[4] = '0';
    temp[5] = '0';
    temp[6] = tab[out_val];




    SendPacket(temp);
    
	// insert your code here
}
