//---------------------------------------------------------------------------
//
// Name:        wxRobotmanDlg.h
// Author:      daqq
// Created:     17/05/2008 12:29:17
// Description: wxRobotmanDlg class declaration
//
//---------------------------------------------------------------------------

#ifndef __WXROBOTMANDLG_h__
#define __WXROBOTMANDLG_h__

#include "wxRobotmanApp.h"

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/dialog.h>
#else
	#include <wx/wxprec.h>
#endif

#include <windows.h>

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/timer.h>
#include <wx/hyperlink.h>
#include <wx/statline.h>
#include <wx/statbox.h>
#include <wx/checkbox.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/listbox.h>
#include <wx/button.h>
////Header Include End

////Dialog Style Start
#undef wxRobotmanDlg_STYLE
#define wxRobotmanDlg_STYLE wxCAPTION | wxSYSTEM_MENU | wxDIALOG_NO_PARENT | wxMINIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End


#define PACKET_LENGTH 9 //the length of the main packet
#define EMPTY_SERIAL_BUFFER 0xFFFF

#define HEX_DEC_ERROR 0xFFFF

//protocol defs.
#define REP_SENSOR_STAT_BUMPER 'b'
#define REP_SENSOR_STAT_ANALOG 'a'
#define REP_OK 'O'


class wxRobotmanDlg : public wxDialog
{
	private:
		DECLARE_EVENT_TABLE();
	
	public:
		wxRobotmanDlg(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("wxRobotman"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxRobotmanDlg_STYLE);
		virtual ~wxRobotmanDlg();
		void b_connectClick(wxCommandEvent& event);
		bool COMConnect(wxString);
		int wxRobotmanDlg::hex_to_dec(char in);
		int wxRobotmanDlg::COMgetch(void);
		bool wxRobotmanDlg::COMputch(char input);
		bool wxRobotmanDlg::SendPacket(char input[PACKET_LENGTH]);
        void b_exitClick(wxCommandEvent& event);
		void update_timerTimer(wxTimerEvent& event);
		void testieClick(wxCommandEvent& event);
		void wxRobotmanDlgActivate(wxActivateEvent& event);
		void b_forwardClick(wxCommandEvent& event);
		void b_backwardClick(wxCommandEvent& event);
		void b_leftClick(wxCommandEvent& event);
		void b_rightClick(wxCommandEvent& event);
		void b_stopClick(wxCommandEvent& event);
		void check_l0Click(wxCommandEvent& event);
	
	private:
		//Do not add custom control declarations between 
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxTimer *update_timer;
		wxStaticText *WxStaticText4;
		wxHyperlinkCtrl *WxHyperLinkCtrl1;
		wxStaticLine *WxStaticLine1;
		wxCheckBox *check_l3;
		wxCheckBox *check_l2;
		wxCheckBox *check_l1;
		wxCheckBox *check_l0;
		wxStaticBox *WxStaticBox1;
		wxCheckBox *check_log_out_packets;
		wxStaticText *WxStaticText3;
		wxTextCtrl *text_robot_name;
		wxButton *testie;
		wxTextCtrl *text_battery_stat;
		wxStaticText *WxStaticText2;
		wxListBox *l_log;
		wxStaticText *WxStaticText1;
		wxTextCtrl *text_comport;
		wxButton *b_exit;
		wxButton *b_connect;
		wxListBox *list_sens_stat;
		wxButton *b_stop;
		wxButton *b_backward;
		wxButton *b_left;
		wxButton *b_right;
		wxButton *b_forward;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_UPDATE_TIMER = 1018,
			ID_WXSTATICTEXT4 = 1034,
			ID_WXHYPERLINKCTRL1 = 1033,
			ID_WXSTATICLINE1 = 1032,
			ID_CHECK_L3 = 1030,
			ID_CHECK_L2 = 1029,
			ID_CHECK_L1 = 1028,
			ID_CHECK_L0 = 1027,
			ID_WXSTATICBOX1 = 1026,
			ID_CHECK_LOG_OUT_PACKETS = 1025,
			ID_WXSTATICTEXT3 = 1023,
			ID_TEXT_ROBOT_NAME = 1022,
			ID_TESTIE = 1021,
			ID_TEXT_BATTERY_STAT = 1020,
			ID_WXSTATICTEXT2 = 1019,
			ID_L_LOG = 1017,
			ID_WXSTATICTEXT1 = 1016,
			ID_TEXT_COMPORT = 1015,
			ID_B_EXIT = 1014,
			ID_B_CONNECT = 1013,
			ID_LIST_SENS_STAT = 1012,
			ID_B_STOP = 1006,
			ID_B_BACKWARD = 1005,
			ID_B_LEFT = 1004,
			ID_B_RIGHT = 1003,
			ID_B_FORWARD = 1002,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};

        	
	private:
        HANDLE hCom;
        char robot_name;
        bool connected;
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
};

#endif
